package de.hft.stuttgart.citydoctor2.webservice.model.entities;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.Access;
import javax.persistence.AccessType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;


@Entity
@Table(name = "users")
public class User {

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY)
	@Access(AccessType.PROPERTY)
	private int id;

	@Column(unique = true, length = 200)
	@NotNull
	private String mail;

	@Column(name = "pw_hash")
	@NotNull
	private String passwordHash;

	@NotNull
	@Column(length = 16)
	private String salt;
	
	@OneToMany(mappedBy = "owner")
	private List<WebCityDoctorModel> ownedModels = new ArrayList<>();

	public List<WebCityDoctorModel> getOwnedModels() {
		return ownedModels;
	}

	public void setOwnedModels(List<WebCityDoctorModel> ownedModels) {
		this.ownedModels = ownedModels;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getMail() {
		return mail;
	}

	public void setMail(String mail) {
		this.mail = mail;
	}

	public String getPasswordHash() {
		return passwordHash;
	}

	public void setPasswordHash(String passwordHash) {
		this.passwordHash = passwordHash;
	}

	public String getSalt() {
		return salt;
	}

	public void setSalt(String salt) {
		this.salt = salt;
	}

	@Override
	public String toString() {
		return "User [id=" + id + ", mail=" + mail + ", passwordHash=" + passwordHash + ", salt=" + salt + "]";
	}

}
